<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<mat-card id="domainInfluenceEdit" class="parameter-edit" [class.read-only]="readOnly">
  <mat-card-header>
    <mat-card-title>{{'parameters.domain-influence.edit.title' | translate}}</mat-card-title>
    <mat-card-subtitle fxLayout="row" fxLayoutAlign="space-between">
      <span>{{'parameters.domain-influence.edit.subtitle' | translate}}</span>
      <span *ngIf="!readOnly">{{'global.forms.fields.required' | translate}}</span>
    </mat-card-subtitle>
  </mat-card-header>
  <mat-card-content class="no-padding">
    <ng-container *roles="['UPLOAD_DOI']">
      <div class="parameter-input" *ngIf="!readOnly">
        <upload-input placeholder="parameters.domain-influence.edit.form.fields.inputFile.placeholder"
                      [uploadUrl]="uploadUrl"
                      fileAccept=".xml"
                      uploadIcon="file_upload"
                      uploadText="global.actions.import"
                      progressText="global.upload-progress"
                      (uploadStarted)="resetUploadResult()"
                      (uploadDone)="processUploadResult($event)">
        </upload-input>
      </div>
    </ng-container>

    <div *ngIf="uploadResult && uploadResult.validationErrors.length > 0"
         id="validationErrors" class="parameter-error"
         fxLayout fxLayoutGap="25px">
      <mat-icon class="parameter-error-icon">warning</mat-icon>
      <span fxFlex fxFlexAlign="auto">{{ 'global.errors.validation-error' | translate }}</span>
      <button mat-button color="primary"
              id="validationErrorsDownloadButton"
              (click)="downloadValidationReport()">
        <mat-icon>file_download</mat-icon>&nbsp;{{ 'global.actions.error-report-download' | translate | uppercase }}
      </button>
    </div>

    <mat-table [hidden]="file.fileName === undefined"
               [dataSource]="fileDataSource"
               id="fileGrid">

      <ng-container matColumnDef="file">
        <mat-header-cell *matHeaderCellDef>
          {{'parameters.domain-influence.edit.file-grid.header.file' | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let file">
          <td-expansion-panel #panel>
            <ng-template td-expansion-panel-header>
              <div fxLayout fxLayoutAlign="stretch center">
                <mat-icon class="td-expand-icon" *ngIf="!panel.expand">keyboard_arrow_right</mat-icon>
                <mat-icon class="td-expand-icon" *ngIf="panel.expand">keyboard_arrow_down</mat-icon>
                <div fxFlex="grow" fxLayout="column">
                  <span><a href="#" (click)="download(file, $event)"
                           class="td-expansion-label">{{file.fileName}}</a></span>
                </div>
              </div>
            </ng-template>
            <domain-influence-grid [domains]="file.details"></domain-influence-grid>
          </td-expansion-panel>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="author">
        <mat-header-cell *matHeaderCellDef>
          {{'parameters.domain-influence.edit.file-grid.header.author' | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let file">
          <div>
            {{file.login}}
          </div>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="importedDate">
        <mat-header-cell *matHeaderCellDef>
          {{'parameters.domain-influence.edit.file-grid.header.imported-date' | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let file">
          <div>
            {{file.saveDate | date:'d.MM.yyyy'}}
          </div>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="delete">
        <mat-header-cell *matHeaderCellDef>
          {{'parameters.domain-influence.edit.file-grid.header.delete' | translate}}
        </mat-header-cell>
        <mat-cell *matCellDef="let file">
          <button mat-icon-button
                  color="accent"
                  (click)="deleteFile()">
            <mat-icon>clear</mat-icon>
          </button>
        </mat-cell>
      </ng-container>

      <mat-header-row *matHeaderRowDef="fileDisplayedColumns"></mat-header-row>
      <mat-row *matRowDef="let row; columns: fileDisplayedColumns;"></mat-row>
    </mat-table>

  </mat-card-content>
</mat-card>
